# Foxchat.NET

a prototype chat server/protocol thing

two types of servers: identity servers, which users log in to and which clients interact with,
and chat servers, which actually host the guilds, channels, and messages.

very *very* much not ready for use yet

code is licensed under the Apache License 2.0

## Packages

- `Foxchat.Core`: shared classes and model definitions
- `Foxchat.Identity`: identity server
- `Foxchat.Chat`: chat server

## Development

- You need [.NET 8][net8] to build Foxchat.
- You also need the [EF Core tools][efcoretools]: `dotnet tool install --global dotnet-ef`
- During early development the configuration files are checked into Git,
  once the software is closer to usable they will be removed and replaced with example files.
- Both servers (Foxchat.Chat and Foxchat.Identity) should be run from their respective directories with `dotnet run`.
- The database can currently be migrated with `dotnet ef database update`, built-in migration will be added later.
- New migrations can be created with `dotnet ef migrations add <name>`.

[net8]: https://dotnet.microsoft.com/en-us/download
[efcoretools]: https://learn.microsoft.com/en-us/ef/core/cli/dotnet
